-- 
-- FarmingTablet - Factory
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 25.09.2017
-- @Version: 1.2.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTablet_App_FactoryExtension = {};
FarmingTablet_App_FactoryExtension.dir  = g_currentModDirectory;
addModEventListener(FarmingTablet_App_FactoryExtension);

FarmingTablet_App_FactoryExtension.name = "mCompanyFactoryExtension";
FarmingTablet_App_FactoryExtension.version = "1.2.0";
print("   [FarmingTablet - FactoryExtension] load " .. tostring(FarmingTablet_App_FactoryExtension.version));

function FarmingTablet_App_FactoryExtension:loadMap()
	g_farmingTablet.utils.loadLanguageText(FarmingTablet_App_FactoryExtension.name, FarmingTablet_App_FactoryExtension.dir.."languageXML.xml");	
	
	local appData = {}; 
	appData.nameOfApp = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"nameApp");
	appData.nameAppstoreButton = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"nameButton");
	appData.name = FarmingTablet_App_FactoryExtension.name;
	appData.isBuyable = true;
	appData.appCategoryDefault = 2;	
	appData.startWindow = "Fabrikscript_overview";
	appData.author = "kevink98";
	appData.version = "1.2";
	appData.priceForAppstore = 2000;
	appData.iconImage = createImageOverlay(FarmingTablet_App_FactoryExtension.dir.."farbrikscriptApp.dds");
	
	appData.useBackgroundsByTablet = true;
	appData.backgroundActiveIndex = 4;
	
	appData.descLine1 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"descLine1");
	appData.descLine2 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"descLine2");
	appData.descLine3 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"descLine3");
	
	appData.modDir = FarmingTablet_App_FactoryExtension.dir;
	g_farmingTablet.modApp.newApp(appData);
	
	g_farmingTablet.utils.addNew_Category_Window(FarmingTablet_App_FactoryExtension, FarmingTablet_App_FactoryExtension.name, "Fabrikscript_overview", "Fabrikscript_PAGE_OVERVIEW", true,true,true)
	g_farmingTablet.utils.addNew_Category_Window(FarmingTablet_App_FactoryExtension, FarmingTablet_App_FactoryExtension.name, "Fabrikscript_infos", "Fabrikscript_PAGE_INFOS", true,true,true)
	g_farmingTablet.utils.loadOverlay(FarmingTablet_App_FactoryExtension.name, FarmingTablet_App_FactoryExtension.dir , "overlays.xml")
	g_farmingTablet.utils.loadButtons(FarmingTablet_App_FactoryExtension.name, FarmingTablet_App_FactoryExtension.dir .. "buttons.xml", FarmingTablet_App_FactoryExtension)
	
	FarmingTablet_App_FactoryExtension.data = {};
	FarmingTablet_App_FactoryExtension.posOverview = 0;
	FarmingTablet_App_FactoryExtension.activeObject = 0;
	FarmingTablet_App_FactoryExtension.object = {};
	FarmingTablet_App_FactoryExtension.mapText = {};
	FarmingTablet_App_FactoryExtension.backupData = {};
	FarmingTablet_App_FactoryExtension.lastNotifications = {};
	FarmingTablet_App_FactoryExtension.timer = 0;
	FarmingTablet_App_FactoryExtension.updateMs = 60000;
	
	if fileExists(g_currentMission.baseDirectory.."modDesc.xml") then
		local xml = loadXMLFile("modDesc",g_currentMission.baseDirectory.."modDesc.xml","modDesc");
		local mapXml = loadXMLFile("map",g_currentMission.baseDirectory..getXMLString(xml, "modDesc.maps.map".."#configFilename"),"map"); 
		local filename = getXMLString(mapXml, "map.ingameMap".."#filename");
		FarmingTablet_App_FactoryExtension.baseMapPDAwidth = getXMLInt(mapXml, "map.ingameMap".."#width");
		
		local i = 0;
		while true do
			local key = string.format("modDesc.l10n.text(%d)",i)
			if not hasXMLProperty(xml,key) then
				break;
			end;
			FarmingTablet_App_FactoryExtension.mapText[getXMLString(xml,key.."#name")] = getXMLString(xml, key.."."..g_languageShort); 
			i = i + 1;
		end;		
	else
		FarmingTablet_App_FactoryExtension.baseMapPDAwidth = 2048;
	end;
	
	FarmingTablet_App_FactoryExtension:findObjects();
	
	local loadApp = function(...) return FarmingTablet_App_FactoryExtension:openApp(...) end;
	local loadAppW = function(...) return FarmingTablet_App_FactoryExtension:openWindow(...) end;
	g_farmingTablet.addAppToOpen(loadApp, appData.startWindow); 
	g_farmingTablet.addAppToOpenWindow(loadAppW, appData.startWindow); 
end;

function FarmingTablet_App_FactoryExtension:openApp() 
	FarmingTablet_App_FactoryExtension:findObjects();
end;

function FarmingTablet_App_FactoryExtension:openWindow() 
	FarmingTablet_App_FactoryExtension:getFabrikscriptInfo();
end;

function FarmingTablet_App_FactoryExtension:update_Fabrikscript_overview()
	if FarmingTablet_App_FactoryExtension.pda == nil then
		FarmingTablet_App_FactoryExtension.pda = createImageOverlay(g_currentMission.ingameMap.mapOverlay.filename);
	end;
	if FarmingTablet_App_FactoryExtension.posOverview > 6 then
		g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_siteBack").visible = true;
	else
		g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_siteBack").visible = false;
	end;
	if FarmingTablet_App_FactoryExtension.data.numObjects > 6 then
		if (FarmingTablet_App_FactoryExtension.posOverview + 6) > FarmingTablet_App_FactoryExtension.data.numObjects then
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_siteContinue").visible = false;
		else
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_siteContinue").visible = true;
		end;
	else
		g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_siteContinue").visible = false;
	end;	
end;

function FarmingTablet_App_FactoryExtension:draw_Fabrikscript_overview()
	renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "backScreenAlpha2").id,0.11,0.27,0.37,0.43);
	renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "backgroundTable").id,0.115,0.635-((FarmingTablet_App_FactoryExtension.activeObject-FarmingTablet_App_FactoryExtension.posOverview) * 0.06),0.36,0.055);
	
	setTextColor(g_farmingTablet.utils.getActiveAppTextColor());
	renderText(0.5-(getTextWidth(0.035 ,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"header"))/2),0.75,0.035,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"header"));	
	renderOverlay(FarmingTablet_App_FactoryExtension.pda, 0.63,0.235,0.27,0.48);
	
	for i=0, 6 do
		local object = FarmingTablet_App_FactoryExtension.data.objects[i+1+FarmingTablet_App_FactoryExtension.posOverview] 
		if object == nil then
			break;
		end;
		
		renderText(0.12, 0.65-(i*0.06),0.034,object.text);
		
		local x,_,z = getWorldTranslation(object.nodeId);
		x = 0.765 + (0.27 / FarmingTablet_App_FactoryExtension.baseMapPDAwidth * x) - 0.0025;
		z = 0.475 + (0.5 / FarmingTablet_App_FactoryExtension.baseMapPDAwidth * -z) - 0.005; 
		if object.id == FarmingTablet_App_FactoryExtension.activeObject+1 then
			renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "on2").id,x,z,0.005,0.01);
		else
			renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "off").id,x,z,0.005,0.01);
		end;
	end;		
	g_farmingTablet.button.drawButtonByCategory("Fabrikscript_PAGE_OVERVIEW");
end;

function FarmingTablet_App_FactoryExtension:update_Fabrikscript_infos()
	FarmingTablet_App_FactoryExtension.object = FarmingTablet_App_FactoryExtension.data.objects[FarmingTablet_App_FactoryExtension.activeObject+1]
end;

function FarmingTablet_App_FactoryExtension:draw_Fabrikscript_infos()
	renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "backScreenAlpha2").id,0.11,0.2,0.61,0.45);
	setTextColor(g_farmingTablet.utils.getActiveAppTextColor());
	renderText(0.2,0.75,0.035,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"Detailoverview")..FarmingTablet_App_FactoryExtension.object.text);
	
	if FarmingTablet_App_FactoryExtension.object.showProduktPerHour then
		renderText(0.28,0.68,0.026,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"ProduktPerHour")..tostring(FarmingTablet_App_FactoryExtension.object.produktPerHour));
	end;
	renderText(0.12,0.6,0.029,FarmingTablet_App_FactoryExtension.object.InputName);
	renderText(0.43,0.6,0.029,FarmingTablet_App_FactoryExtension.object.OutputName);
	
	local i = 0;
	for k,v in pairs(FarmingTablet_App_FactoryExtension.object.rohstoffe) do
		renderText(0.12,0.54-(i*0.04),0.024, v.name)
		renderText(0.22,0.54-(i*0.04),0.024, string.format("%.f / %s",v.fillLevel, v.capacity))
		renderText(0.35,0.54-(i*0.04),0.024, string.format("%.f %%",(v.fillLevel/v.capacity*100)))
		i = i + 1;
	end;
	i = 0;
	for k,v in pairs(FarmingTablet_App_FactoryExtension.object.produkte) do
		renderText(0.43,0.54-(i*0.04),0.024, v.name)
		renderText(0.55,0.54-(i*0.04),0.024, string.format("%.f / %s",v.fillLevel, v.capacity))
		renderText(0.66,0.54-(i*0.04),0.024, string.format("%.f %%",(v.fillLevel/v.capacity*100)))
		i = i + 1;
	end;	
	
	renderOverlay(FarmingTablet_App_FactoryExtension.object.pic, 0.74,0.5,0.16,0.284);
	g_farmingTablet.button.drawButtonByCategory("Fabrikscript_PAGE_INFOS");
end;

function FarmingTablet_App_FactoryExtension:findObjects()
	FarmingTablet_App_FactoryExtension.objects = {};
	if g_currentMission.onCreateLoadedObjects ~= nil then
		for k, onCreateObject in pairs(g_currentMission.onCreateLoadedObjects) do
			if (onCreateObject.FabrikScriptDirtyFlag or onCreateObject.mCompanyFactoryDirtyFlag) and Utils.getNoNil(getUserAttribute(onCreateObject.nodeId, "showOnTablet"), true) then
				onCreateObject.isOnCreate = true;
				table.insert(FarmingTablet_App_FactoryExtension.objects, onCreateObject);
			end;
		end;
	end;
	if g_currentMission.ownedItems ~= nil then
		for k1, items in pairs(g_currentMission.ownedItems) do
			for k2, item in pairs(items.items) do
				if (item.FabrikScriptDirtyFlag or item.mCompanyFactoryDirtyFlag) and Utils.getNoNil(getUserAttribute(item.nodeId, "showOnTablet"), true) then
					table.insert(FarmingTablet_App_FactoryExtension.objects, item);
				end;
			end;
		end;
	end;
end;

function FarmingTablet_App_FactoryExtension:getFabrikscriptInfo()
	local data = {};
	data.numObjects = 0;
	data.objects = {};
	for _, object in pairs(FarmingTablet_App_FactoryExtension.objects) do
		data.numObjects = data.numObjects + 1;					
		data.objects[data.numObjects] = {};
		data.objects[data.numObjects].nodeId = object.nodeId
		data.objects[data.numObjects].id = data.numObjects
		if g_i18n:hasText(getName(object.nodeId)) then
			data.objects[data.numObjects].name = g_i18n:getText(getName(object.nodeId));
		elseif FarmingTablet_App_FactoryExtension.mapText[getName(object.nodeId)] ~= nil then
			data.objects[data.numObjects].name = FarmingTablet_App_FactoryExtension.mapText[getName(object.nodeId)]
		else
			data.objects[data.numObjects].name = getName(object.nodeId);
		end;
		
		local RohstoffText = "Rohstoffe:";
		if g_i18n:hasText(object.InputName) then
			RohstoffText = g_i18n:getText(object.InputName)
		elseif g_i18n:hasText("Rohstoffe") then
			RohstoffText = g_i18n:getText("Rohstoffe")
		end
		local ProdukteText = "Produkte:";
		if g_i18n:hasText(object.OutputName) then
			ProdukteText = g_i18n:getText(object.OutputName)
		elseif g_i18n:hasText("Produkte") then
			ProdukteText = g_i18n:getText("Produkte")
		end
		data.objects[data.numObjects].InputName = RohstoffText;
		data.objects[data.numObjects].OutputName = ProdukteText;

		if g_i18n:hasText(data.objects[data.numObjects].name) then
			data.objects[data.numObjects].text = g_i18n:getText(data.objects[data.numObjects].name);
		else
			data.objects[data.numObjects].text = data.objects[data.numObjects].name;
		end;
		
		data.objects[data.numObjects].showProduktPerHour = Utils.getNoNil(getUserAttribute(object.nodeId, "showProduktPerHour"), true);
		if data.objects[data.numObjects].showProduktPerHour then
			data.objects[data.numObjects].produktPerHour = object.ProduktPerHour;
		end;
		
		data.objects[data.numObjects].rohstoffe = {};
		data.objects[data.numObjects].produkte = {};
		
		
		local i = 0;
		for k,v in pairs(object.Rohstoffe) do
			if v.empty == nil and not v.empty then
				data.objects[data.numObjects].rohstoffe[i] = {};
				data.objects[data.numObjects].rohstoffe[i].name = v.nameL;
				data.objects[data.numObjects].rohstoffe[i].fillLevel = v.fillLevel;
				data.objects[data.numObjects].rohstoffe[i].capacity = v.capacity;
				i = i + 1;
			end;
		end;
		i = 0;
		for k,v in pairs(object.Produkte) do
			if v.empty == nil and not v.empty then
				data.objects[data.numObjects].produkte[i] = {};
				data.objects[data.numObjects].produkte[i].name = v.nameL;
				data.objects[data.numObjects].produkte[i].fillLevel = v.fillLevel;
				data.objects[data.numObjects].produkte[i].capacity = v.capacity;
				i = i + 1;
			end;
		end;
		if object.isOnCreate then
			local pic = getUserAttribute(object.nodeId, "tabletIconName") or getUserAttribute(object.nodeId, "tabletName");
			if pic ~= nil then
				local file = g_currentMission.baseDirectory.."farmingTabletHuds/"..pic..".dds";
				local fileFarmingTablet_App_FactoryExtension = FarmingTablet_App_FactoryExtension.dir.."farmingTabletHuds/"..pic..".dds";
				if fileExists(file) then
					pic = createImageOverlay(file);
				elseif fileExists(fileFarmingTablet_App_FactoryExtension) then
					pic = createImageOverlay(fileFarmingTablet_App_FactoryExtension);
				else
					pic = g_farmingTablet.button.getOverlayByModus_name("image", "emptyPic").id
				end;
			else
				pic = g_farmingTablet.button.getOverlayByModus_name("image", "emptyPic").id
			end;
			data.objects[data.numObjects].pic = pic;
		else
			if fileExists(object.baseDirectory.."modDesc.xml") then
				local xml = loadXMLFile("modDesc",object.baseDirectory.."modDesc.xml","modDesc");
				data.objects[data.numObjects].pic = createImageOverlay(object.baseDirectory .. getXMLString(xml, "modDesc.iconFilename"));
			end;
		end;
	end;
	FarmingTablet_App_FactoryExtension.data = data;
end;

function FarmingTablet_App_FactoryExtension:onActiveClick_OVERVIEW_place(button, para) 
	if FarmingTablet_App_FactoryExtension.data.numObjects >= (FarmingTablet_App_FactoryExtension.posOverview + para) then 
		FarmingTablet_App_FactoryExtension.activeObject = FarmingTablet_App_FactoryExtension.posOverview + para-1; 
		for i=1, 7 do
			if i == para then
				g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_place_" .. tostring(i)).ActivateState = true;
			else
				g_farmingTablet.button.getButtonByApp(FarmingTablet_App_FactoryExtension.name, "OVERVIEW_place_" .. tostring(i)).ActivateState = false;
			end;
		end;
	end;
end;

function FarmingTablet_App_FactoryExtension:onActiveClick_OVERVIEW_siteBack() 
	if not ((FarmingTablet_App_FactoryExtension.posOverview - 7) < 0) then
		FarmingTablet_App_FactoryExtension.posOverview = FarmingTablet_App_FactoryExtension.posOverview - 7;
		FarmingTablet_App_FactoryExtension.activeObject  = FarmingTablet_App_FactoryExtension.posOverview 
	end;
end;
function FarmingTablet_App_FactoryExtension:onActiveClick_OVERVIEW_siteContinue() 
	FarmingTablet_App_FactoryExtension.posOverview = FarmingTablet_App_FactoryExtension.posOverview + 7;
	FarmingTablet_App_FactoryExtension.activeObject  = FarmingTablet_App_FactoryExtension.posOverview 
end;
	
function FarmingTablet_App_FactoryExtension:onActiveClick_OVERVIEW_toInfos() 
	if FarmingTablet_App_FactoryExtension.data.objects[FarmingTablet_App_FactoryExtension.activeObject+1] ~= nil then
		g_farmingTablet.allAppsClose("Fabrikscript_infos");
		FarmingTablet_App_FactoryExtension.object = FarmingTablet_App_FactoryExtension.data.objects[FarmingTablet_App_FactoryExtension.activeObject+1]
	end;
end;
	
function FarmingTablet_App_FactoryExtension:onActiveClick_OVERVIEW_toOverview() 
	g_farmingTablet.allAppsClose("Fabrikscript_overview");
end;
	
function FarmingTablet_App_FactoryExtension:update(dt) 
	self.updateMs = self.updateMs + dt;
	if self.updateMs >= 60000 then
		self.updateMs = self.updateMs - 60000;		
		FarmingTablet_App_FactoryExtension:findObjects();
		for _, object in pairs(FarmingTablet_App_FactoryExtension.objects) do
			if object.Fehler then
				local line1 = "";
				if g_i18n:hasText(getName(object.nodeId)) then
					line1 = g_i18n:getText(getName(object.nodeId));
				elseif FarmingTablet_App_FactoryExtension.mapText[getName(object.nodeId)] ~= nil then
					line1 = FarmingTablet_App_FactoryExtension.mapText[getName(object.nodeId)]
				else
					line1 = getName(object.nodeId);
				end;
				line1 = "Fabrik: "..line1;
				
				local line2 = object.FehlerText[object.Fehler];
				if line2 ~= FarmingTablet_App_FactoryExtension.lastNotifications[getName(object.nodeId)] then
					FarmingTablet_App_FactoryExtension.lastNotifications[getName(object.nodeId)] = line2;
					g_farmingTablet.addNotification(g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_FactoryExtension.name,"nameApp"), line1, line2);
				end;
			else
				FarmingTablet_App_FactoryExtension.lastNotifications[getName(object.nodeId)] = nil;
			end;
		end;
	end;
end;
	
	
function FarmingTablet_App_FactoryExtension:saveMap() end;
function FarmingTablet_App_FactoryExtension:mouseEvent(posX, posY, isDown, isUp, button) end;
function FarmingTablet_App_FactoryExtension:keyEvent(unicode, sym, modifier, isDown) end;
function FarmingTablet_App_FactoryExtension:draw() end;
function FarmingTablet_App_FactoryExtension:delete() end;
function FarmingTablet_App_FactoryExtension:deleteMap() end;